MODULE TextDisplay;
(* =========================================================================  
   Example Cortex-M3 Oberon Program  
 
   Description:
     1. Write the complete character set for the font twice to a display.
        This demonstrates the automatic wrap at end of line and scrolling up 
        at the end of screen.
     2. Redirect runtime error reporting to the display and show the 
        output from a failed assertion.
     
   Target:
     Dependent on the imported modules: Display -> LCDEpson 
     
   Tested on: 
     Olimex LPC1766-STK Development Prototype Board
   
   (c) 2011-2012 CFB Software   
   http://www.astrobe.com  
   
   ========================================================================= *)

IMPORT Display, Main, Out;

PROCEDURE ShowAllChars;
VAR
  ch, firstCh, lastCh: INTEGER;
BEGIN
  firstCh := ORD(" ");
  lastCh := ORD("~");
  FOR ch := firstCh TO lastCh DO 
    Display.Char(CHR(ch))
  END;
  Display.Ln()
END ShowAllChars;


PROCEDURE Run;
VAR
  i: INTEGER;
BEGIN
  Display.Init();
  FOR i := 1 TO 2 DO ShowAllChars() END;
  (* Redirect debug output to display *)
  Out.Init(Display.Char);
  (* Display a debug message *)
  ASSERT(FALSE, 100)
END Run;

BEGIN
  Run
END TextDisplay.
    
